//
//  BNRViewController.m
//  EqualToTiming
//
//  Created by Mark Dalrymple on 3/25/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "BNRViewController.h"


@implementation BNRViewController
@synthesize isEqualLabel = _isEqualLabel;
@synthesize isEqualToLabel = _isEqualToLabel;
@synthesize compareLabel = _compareLabel;


#import <mach/mach_time.h>  // for mach_absolute_time() and friends

// clang -g -Wall -framework Foundation -o equaltime equaltime.m

CGFloat BNRTimeBlock (void (^block)(void)) {
    mach_timebase_info_data_t info;
    if (mach_timebase_info(&info) != KERN_SUCCESS) return -1.0;
    
    uint64_t start = mach_absolute_time ();
    block ();
    uint64_t end = mach_absolute_time ();
    uint64_t elapsed = end - start;
    
    uint64_t nanos = elapsed * info.numer / info.denom;
    return (CGFloat)nanos / NSEC_PER_SEC;
    
} // BNRTimeBlock


#define LOOPAGE 10000000
- (void) compareString: (NSString *) thing1  toString: (NSString *) thing2 {
    CGFloat equalTime = BNRTimeBlock (^{
        for (NSInteger i = 0; i < LOOPAGE; i++) {
            (void) [thing1 isEqual: thing2];
        }
    });
    
    CGFloat equalToStringTime = BNRTimeBlock (^{
        for (NSInteger i = 0; i < LOOPAGE; i++) {
            (void) [thing1 isEqualToString: thing2];
        }
    });
    
    CGFloat compareTime = BNRTimeBlock (^{
        for (NSInteger i = 0; i < LOOPAGE; i++) {
            (void) [thing1 compare: thing2];
        }
    });

    self.isEqualLabel.text = [NSString stringWithFormat: @"isEqual: %f", equalTime];
    self.isEqualToLabel.text = [NSString stringWithFormat: @"isEqualToString: %f", equalToStringTime];
    self.compareLabel.text = [NSString stringWithFormat: @"compare: %f", compareTime];
    
} // CompareStrings


- (IBAction) timeThemStrings: (id) sender {
    NSString *thing1 = @"Hello there, how are you doing today?";
    NSString *thing2 = @"Hello there, how are you doing today!";
    
    [self compareString: thing1  toString: thing2];
} // timeThemStrings


@end // BNRViewController

